// app.c

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include "wdj.h"

VOID __cdecl main(void)
{
    HANDLE handle = NULL;
    ULONG  returned = 0, i;
    BYTE inBuffer[128], outBuffer[128];
    OVERLAPPED overlapped;

    //
    // Fill out an overlapped struct, event should be manual type,
    // initially set to not signalled state.
    //
    overlapped.Offset = 0;
    overlapped.OffsetHigh = 0;
    overlapped.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

    for (i=0; i < 128; i++) {
        inBuffer[i] = 1;
    }

    //
    // Open a handle to the wdj driver for overlapped operation.
    //
    handle = CreateFile("\\\\.\\wdjdrv", GENERIC_READ | GENERIC_WRITE,
                    FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
                    OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);

    if (handle == INVALID_HANDLE_VALUE) {
        printf("Error opening wdj Driver (%d)\n", GetLastError());
        return;
    }

    //
    // Pass the buffers to the driver, asynchronously.
    //
    if (!DeviceIoControl(handle, (DWORD)IOCTL_WDJ_REQUEST,
                    (LPBYTE)inBuffer, 128, (LPBYTE)outBuffer, 128,
                    &returned, &overlapped)) {
        if (GetLastError() == ERROR_IO_PENDING) {
            if (!GetOverlappedResult(handle, &overlapped, &returned, 
                    TRUE)) {
                printf("GetOverlappedResult, %d\n", GetLastError());
                return;
            }
        } else {
            printf("DeviceIoControl, %d\n", GetLastError());
            return;
        }
    }

    for (i=0; i < returned; i++) {
        printf("%04x ", outBuffer[i]);
    }

    CloseHandle(overlapped.hEvent);
    CloseHandle(handle);
}

