//
//  HTTPThreadMgr.h
//

#ifndef _HTTPTHREADMGR_H_
#define _HTTPTHREADMGR_H_

class    CHTTPThread ;

#include <afxtempl.h>

#define	MAX_THREADS     4

#define	WM_THREADCOMPLETE   (WM_USER + 1024)

typedef struct PENDINGLIST
{
    char        szURL[255] ;
    char        szLocalFile[255] ;
    SYSTEMTIME  st ;
} PENDINGLIST ;

class CHTTPThreadMgr
{
public:
    CHTTPThreadMgr() ;
    ~CHTTPThreadMgr() ;


    void                OnThreadComplete(int iThreadNum, 
                                         char *szLocalFile, 
                                         int iStatus) ;

    void                InitThreads(CWnd *pWndCallback, 
                                    char *szTitle) ;
    void                ResetAllThreads() ;
	
    int                 GetPendingRequestCount() ;
    int                 GetWorkingThreadCount() ;

    void                GetRemoteFile(char *szURL, 
                                      char *szLocalFile) ;
    int                 GetNextAvailableThread() ;
    void                RemovePendingRequests() ;

    void                CheckNextRequest() ;

protected:

    CHTTPThread        *m_pIThread[MAX_THREADS] ;

    CList<PENDINGLIST,PENDINGLIST>	*m_pPendingList ;

    CWnd               *m_pWndCallback ;

    void                AddToPendingList(char *szURL, 
                                         char *szLocalFile) ;
    void                RequestFile(int iThread, 
                                    char *szURL, 
                                    char *szLocalFile) ;

    void                DebugMsg(char *szMsg) ;
	
} ;

#endif
