// Microsoft added support for 64 bit integers to
// Visual C++ 5.0.  To minimize the amount of broken
// code this change would cause, 64 bit ints are
// defined using the proprietary keyword '__int64'.
//
// While the ability to manipulate these ultra long
// integers will be a boon to some, Microsoft apparently
// thought that input and output stream operators were
// unnecessary.  Compiling this program generates the
// following messages:
//
// nov97.cpp(35) : error C2593:
//                 'operator <<' is ambiguous
// nov97.cpp(36) : error C2679:
//                 binary '>>' : no operator defined which
//                 takes a right-hand operand of type
//                 '__int64' (or there is no acceptable conversion)
//

#include <iostream>
#include <iomanip>

using namespace std;

main()
{
    __int64 foo = 0x123456789abcdef0;
    __int64 bar;
//
// This generates an error message
//
    cout << foo << "\n";
    cin >> bar;
//
// This works, and demonstrates that all 64 bits are
// being used by the __int64 variable.
//
    cout << hex << (unsigned int)( foo >> 32 )
         << (unsigned int)(foo & 0xffffffff )
         << "\n";

    return 0;
}


