//////////////////////////////////////////////////////////////
//
// SHBrowse.cpp : Windows 4 Shell directory browser
//

#include "stdafx.h"
#include "SHBrowse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////
//
// CShellBrowser object constructor
//
CShellBrowser::CShellBrowser(HWND hParent, int nTitleID)
{
   // set browseinfo structure members
   m_BrowseInfo.pidlRoot = NULL;
   m_BrowseInfo.hwndOwner = hParent;
   m_BrowseInfo.ulFlags =
			BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
   m_BrowseInfo.lpfn = NULL;
   m_BrowseInfo.lParam = 0;

   if (nTitleID > 0)
	  SetTitle(nTitleID);
}

//////////////////////////////////////////////////////////////
//
// Set the title of the dialog
//
void CShellBrowser::SetTitle(LPCSTR szTitle)
{
   strncpy(m_szTitle, szTitle, MAX_PATH);
}

//////////////////////////////////////////////////////////////
//
// Set the title of the dialog
//
void CShellBrowser::SetTitle(int nTitle)
{
   CString csTitle;
   csTitle.LoadString(nTitle);
   strncpy(m_szTitle, csTitle, MAX_PATH);
}

//////////////////////////////////////////////////////////////
//
// Get the selected folder
//
LPCSTR CShellBrowser::GetSelectedFolder(void)
{
   return m_szDirectory;
}

//////////////////////////////////////////////////////////////
//
// Get the BROWSEINFO structure used in the
// SHBrowseForFolder() call
//
BROWSEINFO* CShellBrowser::GetBrowseInfo(void)
{
   return &m_BrowseInfo;
}

//////////////////////////////////////////////////////////////
//
// Uses the Win95 BrowseForFolder shell API to ask the user to
// select a folder.	 Work's only under Win95 and NT 4.0.
//
BOOL CShellBrowser::SelectFolder(void)
{
   LPMALLOC pMalloc;
   BOOL bRC = FALSE;

   // get the Shell's default allocator
   if (SUCCEEDED(::SHGetMalloc(&pMalloc)))
   {
	  LPITEMIDLIST pidl;

	  // setup the BROWSEINFO struct for browse call
	  m_BrowseInfo.pszDisplayName = m_szDirectory;
	  m_BrowseInfo.lpszTitle = m_szTitle;

	  // issue the browse dialog box
	  if ((pidl = ::SHBrowseForFolder(&m_BrowseInfo)) != NULL)
	  {
		 if (SUCCEEDED(::SHGetPathFromIDList(pidl, m_szDirectory)))
			bRC = TRUE;

		 // free the PIDL allocated by SHBrowseForFolder
		 pMalloc->Free(pidl);
	  }

	  // release the shell's allocator 
	  pMalloc->Release();
   }

   return bRC;
}
